<?php

/*
Copyright  2014-2015 Brent "Atomic Blaze" Smith

This file is part of "Party Llama".

    "Party Llama" is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    "Party Llama" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with "Party Llama".  If not, see <http://www.gnu.org/licenses/>.
*/

// So much messy code, a rewrite will be necessary for next version.

if (!defined('SMF'))
	die('Hacking attempt...');

function LlamaLog()
{
	global $scripturl, $context, $smcFunc, $sourcedir, $txt;
	global $context;

	// Delete one or more entries.
	if (!empty($_POST['removeAll']) || (!empty($_POST['removeSelected']) && !empty($_POST['remove']) || !empty($_POST['removeuncaught'])))
	{
		checkSession();

		// 'Delete all entries' button was pressed.
		if (!empty($_POST['removeAll']))
			$smcFunc['db_query']('truncate_table', '
				TRUNCATE {db_prefix}llamas_info',
				array(
				)
			);

		// 'Delete selection' button was pressed.
		elseif (!empty($_POST['remove']))
		{
			// Make sure every entry is integer.
			foreach ($_POST['remove'] as $index => $log_id)
				$_POST['remove'][$index] = (int) $log_id;

			$smcFunc['db_query']('', '
				DELETE FROM {db_prefix}llamas_info
				WHERE id IN ({array_int:llama_list})',
				array(
					'llama_list' => $_POST['remove'],
				)
			);
		}
        // 'Delete uncaught' button was pressed.
        elseif (!empty($_POST['removeuncaught']))
        {
            $smcFunc['db_query']('', "
                DELETE FROM {db_prefix}llamas_info
                WHERE member IS NULL AND caught IS NULL"
            );
        }
	}

	$listOptions = array(
		'id' => 'llamalog',
		'items_per_page' => 30,
		'base_href' => $context['admin_area'] == 'llamalog' ? $scripturl . '?action=admin;area=logs;sa=llamalog' : $scripturl . '?action=admin;area=logs;sa=llamalog',
		'default_sort_col' => 'id',
		'get_items' => array(
			'function' => 'list_getLlamaLogEntries'
		),
		'get_count' => array(
			'function' => 'list_getNumLlamaLogEntries'
		),
		'no_items_label' => $txt['no_llamas'],
		'columns' => array(
			'check' => array(
				'header' => array(
					'value' => '<input type="checkbox" onclick="invertAll(this, this.form);" class="input_check" />'
				),
				'data' => array(
					'sprintf' => array(
						'format' => '<input type="checkbox" name="remove[]" value="%1$d" class="input_check" />',
						'params' => array(
							'id' => false
						)
					),
					'style' => 'text-align: center'
				)
			),
			'id' => array(
				'header' => array(
					'value' => $txt['llama_id']
				),
				'data' => array(
                    'db' => 'id',
                    'style' => 'text-align: center'
				),
				'sort' => array(
					'default' => 'll.id',
					'reverse' => 'll.id DESC'
				)
			),
			'type' => array(
				'header' => array(
					'value' => $txt['llamaadmin_type']
				),
				'data' => array(
					'db' => 'type',
					'style' => 'text-align: center'
				),
				'sort' => array(
					'default' => 'll.type',
					'reverse' => 'll.type DESC'
				)
			),
            'points' => array(
                'header' => array(
                    'value' => $txt['admin_points']
                ),
                'data' => array(
                    'db' => 'points',
					'style' => 'text-align: center'
                )
            ),
			'member' => array(
				'header' => array(
					'value' => $txt['admin_member']
				),
				'data' => array(
                    'db' => 'member',
					'style' => 'text-align: center'
				),
				'sort' => array(
					'default' => 'll.member',
					'reverse' => 'll.member DESC'
				)
			),
			'released' => array(
				'header' => array(
					'value' => $txt['llamaadmin_timer']
				),
				'data' => array(
					'function' => create_function('$rowReleased', '
						return timeformat($rowReleased[\'released\']);
					'),
					'style' => 'text-align: center'
				),
				'sort' => array(
					'default' => 'll.released DESC',
					'reverse' => 'll.released'
				)
			),
            'caught' => array(
                'header' => array(
                    'value' => $txt['llamaadmin_timec']
                ),
				'data' => array(
					'function' => create_function('$rowCaught', '
						$return = timeformat($rowCaught[\'caught\']);
                        
                        if (empty($rowCaught[\'caught\']))
                            return \'-\';
                        else
                            return $return;
					'),
					'style' => 'text-align: center'
				),
                'sort' => array(
                    'default' => 'll.caught DESC',
                    'reverse' => 'll.caught.'
                )
            )
        ),
		'form' => array(
			'href' => $context['admin_area'] == 'modsettings' ? $scripturl . '?action=admin;area=modsettings;sa=LlamaMod' : $scripturl . '?action=admin;area=logs;sa=llamalog',
			'include_start' => true,
			'include_sort' => true
		),
		'additional_rows' => array(
			array(
				'position' => 'below_table_data',
				'value' => '
					<input type="submit" name="removeSelected" value="' . $txt['llama_removeselected'] . '"  class="button_submit" />
					<input type="submit" name="removeAll" value="' . $txt['llamas_removeall'] . '"  class="button_submit" />
                    <input type="submit" name="removeuncaught" value="' . $txt['llamas_removeuncaught'] . '" class="button_submit" />',
				'style' => 'text-align: right;'
			),
		),
	);

	require_once($sourcedir . '/Subs-List.php');
	createList($listOptions);

	$context['page_title'] = $txt['llamatitle'];
	$context['sub_template'] = 'show_list';
	$context['default_list'] = 'llamalog';
}

function list_getLlamas($start, $items_per_page, $sort)
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
			SELECT li.*, m.member_name
			FROM {db_prefix}llamas_info AS li
				LEFT JOIN {db_prefix}members AS m ON (m.id_member=li.member)');
	$llamas = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$llamas[] = $row;

	$smcFunc['db_free_result']($request);

	return $llamas;
}

function list_getNumLlamas()
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT COUNT(*) AS num_llamas
		FROM {db_prefix}llamas_info',
		array(
		)
	);
	list ($numLlamas) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $numLlamas;
}

function list_getLlamaLogEntries($start, $items_per_page, $sort)
{
	global $smcFunc;
    
    if (!isset($sort))
    $sort = 'll.id';
    
	$request = $smcFunc['db_query']('', '
		SELECT ll.*, m.member_name
		FROM {db_prefix}llamas_info AS ll
            LEFT JOIN {db_prefix}members AS m ON(m.id_member=ll.member) 
		ORDER BY {string:sort}
		LIMIT {int:start}, {int:items}',
		array(
            'sort' => $sort,
            'start' => $start,
            'items' => $items_per_page
        )
	);
	$log_entries = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$log_entries[] = $row;
	$smcFunc['db_free_result']($request);

	return $log_entries;
}

function list_getNumLlamaLogEntries()
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}llamas_info AS ll',
		array(
		)
	);
	list ($num_entries) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	return $num_entries;
}

// Let loose the llamas!
function partyLlama()
{
	global $user_info, $modSettings, $smcFunc, $context;
    global $txt;

	// NO GUESTS ALLOWED!
	is_not_guest();
        
	if (isset($_REQUEST['partyLlama']))
		$requestedllama = $_REQUEST['partyLlama'];
    else
        fatal_error($txt['llamas_badid'], true);

	// now lets see if we have a Llama by that name!?
	$request = $smcFunc['db_query']('', '
			SELECT *
			FROM {db_prefix}llamas_info
			WHERE llama_id = {string:llama}
			LIMIT 1',
            array(
                'llama' => $requestedllama
            )
        );

	// Did s/he make it?
	if (!$request || $smcFunc['db_num_rows']($request) == 0)
		fatal_error($txt['llamas_badid'], true);

	$Llamainfo = $smcFunc['db_fetch_assoc']($request);
	$smcFunc['db_free_result']($request);

	// Uh-oh, too late :P
	if (!empty($Llamainfo['member']))
	{
		$context['title'] = $txt['llamas_late'];
		$context['display'] = $modSettings['llamas_late'];
	}
	else
	{
		// let's get your info in the database before someone else gets the Llama!
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}llamas_info
			SET member = {int:user}, caught = {int:caught}
			WHERE llama_id = {string:llama}
			LIMIT 1',
            array(
                'user' => $user_info['id'],
                'caught' => time(),
                'llama' => $requestedllama
            )
            );

		// Log them points
            $smcFunc['db_query']('', '
                UPDATE {db_prefix}members
                SET ' . ($Llamainfo['type'] == 1 ? 'karma_good = karma_good' : 'karma_bad = karma_bad') . ' + ' . $Llamainfo['points'] . '
                WHERE id_member = {int:id}',
                array(
                    'id' => $user_info['id']
                )
            );
            $smcFunc['db_query']('', '
                UPDATE {db_prefix}members
                SET ' . ($Llamainfo['type'] == 1 ? 'goodpoints = goodpoints' : 'badpoints = badpoints') . ' + ' . $Llamainfo['points'] . '
                WHERE id_member = {int:id}',
                array(
                    'id' => $user_info['id']
                )
            );
            $smcFunc['db_query']('', '
                UPDATE {db_prefix}members
                SET ' . ($Llamainfo['type'] == 1 ? 'goodllamas = goodllamas' : 'badllamas = badllamas') . ' + 1'
            );
        
		$context['title'] = $txt['llamagot'] . $modSettings['llamas_type' . $Llamainfo['type']] . '!';
		$context['display'] = str_replace(
					array("%N", "%P", "%K", ":"),
					array(
						$modSettings['llamas_type' . $Llamainfo['type']],
						(($Llamainfo['type']==1) ? $Llamainfo['points'] : $Llamainfo['points']),
						$modSettings['karmaLabel'],
                        ''),
					$modSettings['llamas_type' . $Llamainfo['type'] . '_description']);
	}

	loadTemplate('PartyLlama');
	unset($Llamainfo);
	obExit();
}
?>