<?php

/*
Copyright  2014-2015 Brent "Atomic Blaze" Smith

This file is part of "Party Llama".

    "Party Llama" is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    "Party Llama" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with "Party Llama".  If not, see <http://www.gnu.org/licenses/>.
*/

// If SSI.php is in the same place as this file, and SMF isn't defined, this is being run standalone.
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
{
	require_once(dirname(__FILE__) . '/SSI.php');
}
// Sorry, SMF couldn't be found!
elseif (!defined('SMF')){
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');
}

global $smcFunc;

db_extend('packages');

//Lets try to make a table.
$smcFunc['db_create_table']('{db_prefix}llamas_info',
	array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'type',
			'type' => 'smallint',
			'size' => 2,
            'default' => 0,
		),
		array(
			'name' => 'points',
			'type' => 'tinyint',
            'size' => 3,
            'default' => 0,
		),
		array(
			'name' => 'llama_id',
			'type' => 'varchar',
			'size' => 32,
		),
		array(
			'name' => 'member',
			'type' => 'mediumint',
            'size' => 8,
            'default' => null,
            'null' => true,
		),
		array(
			'name' => 'released',
			'type' => 'int',
			'null' => false,
		),
		array(
			'name' => 'caught',
			'type' => 'int',
			'size' => 10,
			'default' => null,
            'null' => true,
		),
	),
	array(
		array(
			'name' => 'id',
			'type' => 'primary',
			'columns' => array('id'),
		),
	),
	array(),
	'overwrite');
    
//It must have worked, let's insert some settings.
$smcFunc['db_insert']('ignore', '{db_prefix}settings',
    array(
        'variable' => 'string',
        'value' => 'string',
    ),
    array(
        array('llamas_enable', '0'),
		array('llamas_disabled', 'admin,profile,help,helpadmin,login,post,partyLlama, moderate'),
        array('llamas_chances', '15'),
		array('llamas_image', 'Party_Llama2.gif'),
		array('llamas_type1', 'Good Llama'),
		array('llamas_type1_min_points', '1'),
		array('llamas_type1_max_points', '5'),
		array('llamas_type1_description', 'Hello, I am the %N, I have rewarded you with %P point(s) to your %K.'),
		array('llamas_type2', 'Bad Llama'),
		array('llamas_type2_min_points', '0'),
		array('llamas_type2_max_points', '4'),
		array('llamas_type2_description', '<strong>I am the %N and have taken %P point(s) from your %K!</strong>'),
		array('llamas_late', 'Sorry! You were to late another member has caught the llama!'),
		array('llamas_width', '0'),
		array('llamas_height', '0'),
		array('llamas_speed', '50')
    ),
    array()
);
    
//Since we want everything to be empty when this finishes we won't do anything else.
if(SMF == 'SSI')
	echo 'Success!';

?>